# Copyright (C) 2009 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


LPATH := $(call my-dir)

BOOST_PATH = $(LibsPathCygwin)/boost_1_47_0

#====== BOOST =====================


LOCAL_PATH := $(BOOST_PATH)

include $(CLEAR_VARS)

LOCAL_MODULE    := boost
LOCAL_C_INCLUDES := $(BOOST_PATH)

#thread
LOCAL_SRC_FILES := /libs/thread/src/pthread/thread.cpp
LOCAL_SRC_FILES += /libs/thread/src/pthread/once.cpp

#signals
LOCAL_SRC_FILES += /libs/signals/src/connection.cpp
LOCAL_SRC_FILES += /libs/signals/src/named_slot_map.cpp
LOCAL_SRC_FILES += /libs/signals/src/signal_base.cpp
LOCAL_SRC_FILES += /libs/signals/src/slot.cpp
LOCAL_SRC_FILES += /libs/signals/src/trackable.cpp

#system
LOCAL_SRC_FILES += /libs/system/src/error_code.cpp

#regex
LOCAL_SRC_FILES += /libs/regex/src/c_regex_traits.cpp
LOCAL_SRC_FILES += /libs/regex/src/cpp_regex_traits.cpp
LOCAL_SRC_FILES += /libs/regex/src/cregex.cpp
LOCAL_SRC_FILES += /libs/regex/src/fileiter.cpp
LOCAL_SRC_FILES += /libs/regex/src/icu.cpp
LOCAL_SRC_FILES += /libs/regex/src/instances.cpp
LOCAL_SRC_FILES += /libs/regex/src/posix_api.cpp
LOCAL_SRC_FILES += /libs/regex/src/regex.cpp
LOCAL_SRC_FILES += /libs/regex/src/regex_debug.cpp
LOCAL_SRC_FILES += /libs/regex/src/regex_raw_buffer.cpp
LOCAL_SRC_FILES += /libs/regex/src/regex_traits_defaults.cpp
LOCAL_SRC_FILES += /libs/regex/src/static_mutex.cpp
LOCAL_SRC_FILES += /libs/regex/src/usinstances.cpp
LOCAL_SRC_FILES += /libs/regex/src/w32_regex_traits.cpp
LOCAL_SRC_FILES += /libs/regex/src/wc_regex_traits.cpp
LOCAL_SRC_FILES += /libs/regex/src/wide_posix_api.cpp
LOCAL_SRC_FILES += /libs/regex/src/winstances.cpp

#date_time
LOCAL_SRC_FILES += /libs/date_time/src/gregorian/greg_month.cpp
LOCAL_SRC_FILES += /libs/date_time/src/gregorian/greg_weekday.cpp
LOCAL_SRC_FILES += /libs/date_time/src/gregorian/date_generators.cpp

#asio
#nothing



LOCAL_LDLIBS     := -llog -Wl

#debug
#LOCAL_CFLAGS := -g -ggdb -O0
#LOCAL_LDLIBS     += -g -ggdb 


include $(BUILD_STATIC_LIBRARY)


#================= THE APP =======================


LOCAL_PATH:= $(LPATH)

include $(CLEAR_VARS)

LOCAL_STATIC_LIBRARIES := boost
LOCAL_C_INCLUDES := $(BOOST_PATH)
LOCAL_C_INCLUDES += ../../common
LOCAL_MODULE    := KObserver
LOCAL_SRC_FILES := main_code.cpp
LOCAL_SRC_FILES += android_api.cpp

LOCAL_SRC_FILES += ../../common/ClientSocket.cpp
LOCAL_SRC_FILES += ../../common/MessageSender.cpp
LOCAL_SRC_FILES += ../../common/misc.cpp
LOCAL_SRC_FILES += ../../common/UserInfo.cpp

LOCAL_LDLIBS    := -llog -Wl,-s

include $(BUILD_SHARED_LIBRARY)
