//
//  AppDelegate.m
//  k-observer-iphone
//
//  Created by vvv ооо on 26.08.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"

#import "ConnectViewController.h"
#import "MainMenuViewController.h"
#import "ProfileViewController.h"
#import "AlarmViewController.h"
#import "MapViewController.h"
#import "MessagesViewController.h"
#import "SendMessageViewController.h"

AppDelegate* appDelegate;

@implementation AppDelegate

@synthesize window = _window;
@synthesize navController = _navController;
@synthesize connectViewController = _connectViewController;
@synthesize mainMenuViewController = _mainMenuViewController;
@synthesize profileViewController = _profileViewController;
@synthesize alarmViewController = _alarmViewController;
@synthesize mapViewController = _mapViewController;
@synthesize messagesViewController = _messagesViewController;
@synthesize sendMessageViewController = _sendMessageViewController;

@synthesize navigationControllerDelegate = _navigationControllerDelegate;

@synthesize spinner = _spinner;

@synthesize observerClient = _observerClient;
@synthesize locationManager = _locationManager;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    // Override point for customization after application launch.
    
    
    self.connectViewController = [[ConnectViewController alloc] initWithNibName:@"ConnectViewController" bundle:nil];
    
    self.connectViewController.title = @"Вход";
    
    self.mainMenuViewController = [[MainMenuViewController alloc] initWithNibName:@"MainMenuViewController" bundle:nil];
    
    self.mainMenuViewController.title = @"Главное меню";
    
    self.profileViewController = [[ProfileViewController alloc] initWithNibName:@"ProfileViewController" bundle:nil];
    
    self.profileViewController.title = @"Профиль";
    
    self.profileViewController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    
    self.alarmViewController = [[AlarmViewController alloc] initWithNibName:@"AlarmViewController" bundle:nil];
    
    self.alarmViewController.title = @"Тревога";
    
    self.alarmViewController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    
    self.mapViewController = [[MapViewController alloc] initWithNibName:@"MapViewController" bundle:nil];
    
    self.mapViewController.title = @"Карта";

    
    self.messagesViewController = [[MessagesViewController alloc] initWithNibName:@"MessagesViewController" bundle:nil];
    
    self.messagesViewController.title = @"Сообщения";
    
    self.sendMessageViewController = [[SendMessageViewController alloc] initWithNibName:@"SendMessageViewController" bundle:nil];
    
    self.navigationControllerDelegate = [[NavigationControllerDelegate alloc] init];
    
    self.navController = [[UINavigationController alloc] initWithRootViewController:self.connectViewController];
    
    self.navController.delegate = self.navigationControllerDelegate;
    
    self.window.rootViewController = self.navController;
    [self.window makeKeyAndVisible];
    
    self.observerClient = [[ObserverClient alloc] init];
    
    self.locationManager = [[CLLocationManager alloc] init];
    self.locationManager.delegate = self;
    self.locationManager.distanceFilter = kCLDistanceFilterNone; // whenever we move
    self.locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    [self.locationManager startUpdatingLocation];
    
    //Force lazy load
    //[self.mapViewController view]; //NO
    [self.alarmViewController view];
    [self.profileViewController view];
    [self.sendMessageViewController view];
    [self.messagesViewController view];
    
    appDelegate = self;
    
    CGPoint p = self.connectViewController.view.center;
    
    self.spinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [self.spinner setCenter:p]; // I do this because I'm in landscape mode
    [self.connectViewController.view addSubview:self.spinner]; // spinner is not visible until started
    
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

-(void)gotoMainMenu
{
    @autoreleasepool
    {
        [self performSelectorOnMainThread:@selector(gotoMainMenuImmediate) withObject:nil waitUntilDone:NO];
    }
}

-(void)gotoMainMenuImmediate
{
    @autoreleasepool
    {
        [self.spinner stopAnimating];
        [self.navController pushViewController:self.mainMenuViewController animated:YES];
    }
}

- (void)locationManager:(CLLocationManager *)manager
    didUpdateToLocation:(CLLocation *)newLocation
           fromLocation:(CLLocation *)oldLocation
{
    float lon = newLocation.coordinate.longitude;
    float lat = newLocation.coordinate.latitude;
    
    [appDelegate.observerClient UpdateLon:lon Lat:lat];
}

@end
